import style;
import graph;

real[][] data_from_csv(string file_name) {
    file fin = input(file_name);
    real[][] data = fin.line().csv();
    return data;
}

pair position_on_graph(
    real[] horizontal_data, real[] vertical_data, real horizontal_position)
{
    int current = 0;
    while (horizontal_data[current] < horizontal_position) {
        ++ current;
        if (current == horizontal_data.length) {
            // We've falled off the end of the graph.
            return (horizontal_data[current-1], vertical_data[current-1]);
        }
    }
    
    real x0 = horizontal_data[current-1];
    real x1 = horizontal_data[current];
    real y0 = vertical_data[current-1];
    real y1 = vertical_data[current];

    real fraction = (horizontal_position - x0) / (x1 - x0);

    if (fraction < 0)
        fraction = 0;

    real vertical_position = (1-fraction) * y0 + fraction * y1;
    return (horizontal_position, vertical_position);
}

void draw_from_csv(picture pic=currentpicture, string file_name, pen p,
    string label_text="", real label_x=0, pair label_align=(0,0),
    real data_scale=1.0)
{
    real[][] data=transpose(data_from_csv(file_name));

    real[] x = data[0];
    real[] y = data[1];
    for (int i = 0; i < y.length; ++ i)
        y[i] *= data_scale;

    pair label_location = position_on_graph(x, y, label_x);

    draw(pic, graph(x,y), p);
    if (label_text != "")
        label(pic, Label(label_text, label_location, p, align=label_align));
}

size(8cm, 4.5cm, IgnoreAspect);

draw_from_csv("mhsa_wer_duration.csv",
    samsung_blue, "MHSA", label_x=32.5, label_align=N);
draw_from_csv("fastformer_wer_duration.csv",
    other_colours[2], "FastFormer", label_x=32.5, label_align=NE);
draw_from_csv("summarymixinglite_wer_duration.csv",
    other_colours[5], "SummaryMixing-lite", label_x=32.5, label_align=ENE);
draw_from_csv("summarymixing_wer_duration.csv",
    other_colours[6], "SummaryMixing", label_x=32.5, label_align=SE);

xaxis("Utterance length (s)", YEquals(8), xmin=0, RightTicks);
yaxis("Word error rate", ymin=8, ymax=20, LeftTicks);
