import style;
import graphical;
import draw_summary_mixing;
import branchformer_helpers;

void draw_branchformer_summary_mixing() {
    picture[] behind = {new picture, new picture, new picture};
    SummaryMixingParts summary_mixing = draw_summary_mixing(behind);

    FloatingObject merged_box[] = vector_slices(2);

    path conv = draw_conv(summary_mixing.combined_lower);

    // Place vertically.
    merged_box = next_to(
        summary_mixing.output_vector,
        0.7*after_gap, merged_box, reference_bounding_box=true);
    
    // Place horizontally.
    real merged_box_target_x = 0.5 * (
        centre(conv) + centre(summary_mixing.output_vector)).x;
    pair merged_box_current_location = centre(combine(merged_box).outline);

    path[] merged = draw_at(
        (merged_box_target_x - merged_box_current_location.x, 0),
        merged_box);

    actually_draw_arrow(cut_line_from_to(
            centre(summary_mixing.output_vector) -- (centre(summary_mixing.output_vector).x, centre(merged[0]).y)
            -- centre(merged[0]),
            summary_mixing.output_vector, merged[0]));

    actually_draw_arrow(cut_line_from_to(
            centre(conv) -- (centre(conv).x, centre(merged[1]).y)
            -- centre(merged[1]),
            conv, merged[1]));

    FloatingObject projection_box = process_box("MLP", width_factor=0.8);
    path projection_ = draw_next_to(combine(merged), after_gap, projection_box);

    draw_arrow(combine(merged), projection_);

    InputVector phantom_input = draw_phantom_input(new path[] {conv,
        summary_mixing.input_functions[0], summary_mixing.input_functions[1]});

    path add_residual = draw_residual(
        phantom_input.first_corner, conv, projection_);

    draw_plates(behind,
        combine(combine(conv, summary_mixing.combined_lower), add_residual));
}

draw_branchformer_summary_mixing();
