import style;
import graphical;
import draw_summary_mixing;
import branchformer_helpers;

void draw_conformer() {
    picture[] behind = {new picture, new picture, new picture};

    FloatingObject feed_forward_box = process_box("MLP", width_factor=0.8);

    path feed_forward = draw_at((0,0), feed_forward_box);

    InputVector phantom_input = draw_phantom_input(new path[]{
        feed_forward });

    path residual1 = draw_residual(
        phantom_input.first_corner, feed_forward, feed_forward,
        with_phantom_output=false);

    path attention = draw_next_to(residual1, after_gap, attention_box());

    for (int i: new int[] {1, 2}) {
        draw_at(behind[i-1], centre(attention) + i * time_plate_offset,
            attention_box(with_text=false));
    }

    path arrow1 = draw_arrow(residual1, attention);

    path residual2 = draw_residual(
        point(arrow1, 0.4), attention, attention,
        with_phantom_output=false);
    
    FloatingObject conv_box = process_box("Convolution", width_factor=1.4);

    path conv = draw_next_to(residual2, after_gap, conv_box);

    path arrow2 = draw_arrow(residual2, conv);

    path residual3 = draw_residual(
        point(arrow2, 0.4), conv, conv,
        with_phantom_output=false);
    
    path feed_forward_2 = draw_next_to(residual3, after_gap, feed_forward_box);

    path arrow3 = draw_arrow(residual3, feed_forward_2);

    path residual4 = draw_residual(
        point(arrow3, 0.4), feed_forward_2, feed_forward_2,
        with_phantom_output=true);

    draw_plates(behind,
        combine(combine(feed_forward, attention), residual4));
}

draw_conformer();
