import style;
import graphical;

pair horizontal = (process_gap.y, process_gap.x);

real right_plate_margin = 0.5 * reflen;

FloatingObject feature_extractor_box = process_box(
    "Feature\\extractor", num_lines=2);
FloatingObject sumformer_box = process_box("SumFormer\\encoder\\block",
    num_lines=3, width_factor=1.3);

FloatingObject positional_encoding_box = text_box(
    "Positional\\encoding", num_lines=2);
FloatingObject input_box = text_box("Audio");
FloatingObject encoder_output_box = text_box("Output");

path input = draw_at((0,0), input_box);

path feature_extractor = draw_next_to(input, process_gap,
    feature_extractor_box);

path plus = draw_next_to(feature_extractor, process_gap, plus_box());

path positional_encoding = draw_next_to(plus, -horizontal, positional_encoding_box);

path sumformer_block = draw_next_to(plus, process_gap,
    with_plate_around(
        sumformer_box,
        right_margin=right_plate_margin,
        corner_radius=process_radius + 0.5*plate_margin,
        fillpen=make_shade_box_pen(samsung_blue) + .5white
    )
);
label_inside(sumformer_block, "$N$", direction=ENE);

path output = draw_next_to(sumformer_block, process_gap, encoder_output_box);

draw_arrow(input, feature_extractor);
draw_arrow(feature_extractor, plus);
draw_arrow(positional_encoding, plus);
draw_arrow(plus, sumformer_block);
draw_arrow(sumformer_block, output);
