import style;
import graphical;
import draw_summary_mixing;
import branchformer_helpers;

real time_gap_1 = 0.15 * reflen;
real time_gap_2 = 0.10 * reflen;

SummaryMixingParts draw_hypermixer(picture[] behind) {
    SummaryMixingParts entry_points;

    FloatingObject local_transformation_box = function_box("$\Transformation$");
    FloatingObject global_transformation_box = function_box("$\Transformation'$");
    // TODO not average
    FloatingObject sum_box = function_box("$\sum$", size_up=1.7);

    path local_transformation = draw_at((0,0), local_transformation_box);
    path global_transformation = draw_next_to(
        local_transformation, -parallel_gap, global_transformation_box);
    path cross_product = draw_next_to(
        global_transformation, -parallel_gap, times_box());
    
    draw_arrow(global_transformation, cross_product);


    transform time_arrow_spacing = shift(0, time_gap_1);
    FloatingObject moved_sum_box = next_to(
        cross_product, -2 * parallel_gap, sum_box);
    path sum = draw_at((0,0),
        time_arrow_spacing * moved_sum_box);
    {
        path a = draw_arrow(cross_product, moved_sum_box.outline,
            pen_for_source[0], "$1$",
            axis_aligned=true,
            label_position=.8, label_align=S);
        actually_draw_arrow(behind[0], time_arrow_spacing * a,
            pen_for_source[1]);
        actually_draw_arrow(behind[1],
            time_arrow_spacing * time_arrow_spacing * a,
            pen_for_source[2],
            "$\Length$", label_position=.8, label_align=N);
    }

    path relu = draw_next_to(sum, after_gap, soft_relu_box());

    draw_arrow(sum, relu);

    path combiner = draw_at(
        (centre(local_transformation).x, centre(relu).y - time_gap_2), matmul_box());
    
    draw_arrow(local_transformation, combiner);

    draw_arrow(relu, combiner, parallel=0.5 * time_gap_2, axis_aligned=true);
    draw_arrow(behind[0], relu, combiner,
        parallel=-0.5 * time_gap_2, axis_aligned=true);
    draw_arrow(behind[1], relu, combiner,
        parallel=-1.5 * time_gap_2, axis_aligned=true);


    // {
    //     path feedback_line = cut_line_from_to(
    //         centre(sum) -- (centre(sum).x, centre(combiner).y)
    //         -- centre(combiner), sum, combiner);
    //     actually_draw_arrow(feedback_line);
    //     actually_draw_arrow(behind[0], time_arrow_spacing * feedback_line);
    //     actually_draw_arrow(behind[1],
    //         time_arrow_spacing * time_arrow_spacing * feedback_line);
    // }


    entry_points.input_functions.push(local_transformation);
    entry_points.input_functions.push(global_transformation);
    entry_points.input_functions.push(cross_product);

    entry_points.combined_lower = combine(entry_points.input_functions);

    entry_points.output_vector = combiner;

    return entry_points;
}

picture[] behind = {new picture, new picture, new picture};
SummaryMixingParts entry_points = draw_hypermixer(behind);

InputVector input_vector = draw_input_vector(entry_points.input_functions,
    vector("$\InputVector_{\Time}$"));

path output_vector = draw_output_vector(entry_points.output_vector,
    vector("$\OutputVector_{\Time}$"));

// draw_shadow_vector(behind, input_vector.input_vector);
// draw_shadow_vector(behind, output_vector);

draw_time_plates(behind,
    combine(entry_points.combined_lower, entry_points.output_vector),
    attention_plate_base_colour,
    right_margin=0.1 * reflen,
    top_margin=0.2 * reflen,
    bottom_margin=0.4 * reflen);
