import graph;
import style;
import general;

size(5cm, 4.5cm, IgnoreAspect);

real data_scale = 1e-4 * 1e5;

draw_system("_rtf", branchformer, label_x=50, label_align=NW,
    data_scale=data_scale);
// draw_system("_rtf", contextnet, label_x=50, label_align=NW,
//     data_scale=data_scale);
draw_system("_rtf", fastformer, label_x=30, label_align=NE,
    data_scale=data_scale);
draw_system("_rtf", summary_mixing, label_x=40, label_align=SW,
    data_scale=data_scale);
draw_system("_rtf", summary_mixing_lite, label_x=40, label_align=W,
    data_scale=data_scale);

real y_min = 0.3 * data_scale;

xaxis("Utterance length (s)", YEquals(y=y_min, extend=false), LeftTicks);
yaxis("Real-time factor ($10^{-5}$)", ymin=y_min, LeftRight, RightTicks);
