import style;

import graph;

real[][] data_from_file(string file_name) {
    file fin = input(file_name);
    real[][] data = fin.line();
    return data;
}

pair position_on_graph(
    real[] horizontal_data, real[] vertical_data, real horizontal_position)
{
    int current = 0;
    while (horizontal_data[current] < horizontal_position) {
        ++ current;
        if (current == horizontal_data.length) {
            // We've falled off the end of the graph.
            return (horizontal_data[current-1], vertical_data[current-1]);
        }
    }
    
    real x0 = horizontal_data[current-1];
    real x1 = horizontal_data[current];
    real y0 = vertical_data[current-1];
    real y1 = vertical_data[current];

    real fraction = (horizontal_position - x0) / (x1 - x0);

    if (fraction < 0)
        fraction = 0;

    real vertical_position = (1-fraction) * y0 + fraction * y1;
    return (horizontal_position, vertical_position);
}

void draw_from_file(picture pic=currentpicture, string file_name, pen p,
    string label_text="", real label_x=0, pair label_align=(0,0),
    real data_scale=1.0)
{
    real[][] data=transpose(data_from_file(file_name));

    real[] x = data[0];
    real[] y = data[1];
    for (int i = 0; i < y.length; ++ i)
        y[i] *= data_scale;

    pair label_location = position_on_graph(x, y, label_x);

    draw(pic, graph(x,y), p);
    if (label_text != "")
        label(pic, Label(label_text, label_location, p, align=label_align));
}

real[][] draw_from_file_no_label(picture pic=currentpicture,
    string file_name, pen p, real data_scale=1.0) {
    real[][] data = transpose(data_from_file(file_name));

    real[] x = data[0];
    real[] y = data[1];
    for (int i = 0; i < y.length; ++ i)
        y[i] *= data_scale;

    draw(pic, graph(x,y), p);
    return data;
}

struct System {
    string file_name;
    string label;
    pen colour;
};

void draw_system(picture pic=currentpicture, string file_ext, System system,
    real label_x=0, pair label_align=(0,0),
    real data_scale=1.0)
{
    string file_name = "../../resources/" + system.file_name + file_ext + ".txt";
    draw_from_file(pic, file_name, system.colour, system.label,
        label_x, label_align, data_scale);
}

real[][] draw_system_no_label(picture pic=currentpicture, string file_ext, System system,
    real data_scale=1.0)
{
    string file_name = "../../resources/" + system.file_name + file_ext + ".txt";
    return draw_from_file_no_label(pic, file_name, system.colour, data_scale);
}

void label_top_of_frame(frame f, transform t, string label) {
    pair top = t * (0.5 * (min(f) + max(f)).x, max(f).y);
    label(top, label, align=N);
}

System branchformer;
branchformer.file_name = "branchformer";
branchformer.label = "MHSA";
branchformer.colour = samsung_blue;

System contextnet;
contextnet.file_name = "contextnet";
contextnet.label = "ContextNet";
contextnet.colour = other_colours[0];

System fastformer;
fastformer.file_name = "fastformer";
fastformer.label = "FastFormer";
fastformer.colour = other_colours[2];

System summary_mixing;
summary_mixing.file_name = "mlgs";
summary_mixing.label = "Sum.Mix.";
summary_mixing.colour = other_colours[6];

System summary_mixing_lite;
summary_mixing_lite.file_name = "mgs";
summary_mixing_lite.label = "Sum.Mix.-lite";
summary_mixing_lite.colour = other_colours[5];

